Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -1119,235 +1410,269 @@
                     return Status;
                 }
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (level == 0)
             break;
-        
+
         level--;
     } while (TRUE);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS update_root_root(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS update_root_root(device_extension* Vcb, BOOL no_cache, PIRP Irp, LIST_ENTRY* rollback) {
     LIST_ENTRY* le;
     NTSTATUS Status;
-    
+
     TRACE("(%p)\n", Vcb);
-    
+
     le = Vcb->trees.Flink;
     while (le != &Vcb->trees) {
         tree* t = CONTAINING_RECORD(le, tree, list_entry);
-        
+
         if (t->write && !t->parent) {
             if (t->root != Vcb->root_root && t->root != Vcb->chunk_root) {
                 KEY searchkey;
                 traverse_ptr tp;
-                
+
                 searchkey.obj_id = t->root->id;
                 searchkey.obj_type = TYPE_ROOT_ITEM;
                 searchkey.offset = 0xffffffffffffffff;
-                
+
                 Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
                 if (!NT_SUCCESS(Status)) {
                     ERR("error - find_item returned %08x\n", Status);
                     return Status;
                 }
-                
+
                 if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
                     ERR("could not find ROOT_ITEM for tree %llx\n", searchkey.obj_id);
-                    int3;
                     return STATUS_INTERNAL_ERROR;
                 }
-                
+
                 TRACE("updating the address for root %llx to %llx\n", searchkey.obj_id, t->new_address);
-                
+
                 t->root->root_item.block_number = t->new_address;
                 t->root->root_item.root_level = t->header.level;
                 t->root->root_item.generation = Vcb->superblock.generation;
                 t->root->root_item.generation2 = Vcb->superblock.generation;
-                
+
                 // item is guaranteed to be at least sizeof(ROOT_ITEM), due to add_parents
 
                 RtlCopyMemory(tp.item->data, &t->root->root_item, sizeof(ROOT_ITEM));
             }
-            
+
             t->root->treeholder.address = t->new_address;
+            t->root->treeholder.generation = Vcb->superblock.generation;
         }
-        
+
         le = le->Flink;
     }
-    
-    Status = update_chunk_caches(Vcb, Irp, rollback);
-    if (!NT_SUCCESS(Status)) {
-        ERR("update_chunk_caches returned %08x\n", Status);
-        return Status;
+
+    if (!no_cache && !(Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE)) {
+        ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
+        Status = update_chunk_caches(Vcb, Irp, rollback);
+        ExReleaseResourceLite(&Vcb->chunk_lock);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("update_chunk_caches returned %08x\n", Status);
+            return Status;
+        }
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-NTSTATUS do_tree_writes(device_extension* Vcb, LIST_ENTRY* tree_writes, PIRP Irp) {
+NTSTATUS do_tree_writes(device_extension* Vcb, LIST_ENTRY* tree_writes, BOOL no_free) {
     chunk* c;
     LIST_ENTRY* le;
     tree_write* tw;
     NTSTATUS Status;
+    ULONG i, num_bits;
     write_data_context* wtc;
-    
-    wtc = ExAllocatePoolWithTag(NonPagedPool, sizeof(write_data_context), ALLOC_TAG);
-    if (!wtc) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    KeInitializeEvent(&wtc->Event, NotificationEvent, FALSE);
-    InitializeListHead(&wtc->stripes);
-    wtc->tree = TRUE;
-    wtc->stripes_left = 0;
-    
+    ULONG bit_num = 0;
+    BOOL raid56 = FALSE;
+
     // merge together runs
     c = NULL;
     le = tree_writes->Flink;
     while (le != tree_writes) {
         tw = CONTAINING_RECORD(le, tree_write, list_entry);
-        
+
         if (!c || tw->address < c->offset || tw->address >= c->offset + c->chunk_item->size)
             c = get_chunk_from_address(Vcb, tw->address);
         else {
             tree_write* tw2 = CONTAINING_RECORD(le->Blink, tree_write, list_entry);
-            
+
             if (tw->address == tw2->address + tw2->length) {
                 UINT8* data = ExAllocatePoolWithTag(NonPagedPool, tw2->length + tw->length, ALLOC_TAG);
-                
+
                 if (!data) {
                     ERR("out of memory\n");
-                    ExFreePool(wtc);
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 RtlCopyMemory(data, tw2->data, tw2->length);
                 RtlCopyMemory(&data[tw2->length], tw->data, tw->length);
-                
-                ExFreePool(tw2->data);
+
+                if (!no_free)
+                    ExFreePool(tw2->data);
+
                 tw2->data = data;
                 tw2->length += tw->length;
-                
-                ExFreePool(tw->data);
+
+                if (!no_free) // FIXME - what if we allocated this just now?
+                    ExFreePool(tw->data);
+
                 RemoveEntryList(&tw->list_entry);
                 ExFreePool(tw);
-                
+
                 le = tw2->list_entry.Flink;
                 continue;
             }
         }
-        
+
+        tw->c = c;
+
+        if (c->chunk_item->type & (BLOCK_FLAG_RAID5 | BLOCK_FLAG_RAID6))
+            raid56 = TRUE;
+
         le = le->Flink;
     }
-    
-    // mark RAID5/6 overlaps so we can do them one by one
-    c = NULL;
+
+    num_bits = 0;
+
     le = tree_writes->Flink;
     while (le != tree_writes) {
         tw = CONTAINING_RECORD(le, tree_write, list_entry);
-        
-        if (!c || tw->address < c->offset || tw->address >= c->offset + c->chunk_item->size)
-            c = get_chunk_from_address(Vcb, tw->address);
-        else if (c->chunk_item->type & BLOCK_FLAG_RAID5) {
-            tree_write* tw2 = CONTAINING_RECORD(le->Blink, tree_write, list_entry);
-            UINT64 last_stripe, this_stripe;
-            
-            last_stripe = (tw2->address + tw2->length - 1 - c->offset) / (c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 1));
-            this_stripe = (tw->address - c->offset) / (c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 1));
-            
-            if (last_stripe == this_stripe)
-                tw->overlap = TRUE;
-        } else if (c->chunk_item->type & BLOCK_FLAG_RAID6) {
-            tree_write* tw2 = CONTAINING_RECORD(le->Blink, tree_write, list_entry);
-            UINT64 last_stripe, this_stripe;
-            
-            last_stripe = (tw2->address + tw2->length - 1 - c->offset) / (c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 2));
-            this_stripe = (tw->address - c->offset) / (c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 2));
-            
-            if (last_stripe == this_stripe)
-                tw->overlap = TRUE;
-        }
-        
+
+        num_bits++;
+
         le = le->Flink;
     }
-    
+
+    wtc = ExAllocatePoolWithTag(NonPagedPool, sizeof(write_data_context) * num_bits, ALLOC_TAG);
+    if (!wtc) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+
     le = tree_writes->Flink;
+
     while (le != tree_writes) {
         tw = CONTAINING_RECORD(le, tree_write, list_entry);
-        
-        if (!tw->overlap) {
-            TRACE("address: %llx, size: %x, overlap = %u\n", tw->address, tw->length, tw->overlap);
-            
-            Status = write_data(Vcb, tw->address, tw->data, TRUE, tw->length, wtc, NULL, NULL);
-            if (!NT_SUCCESS(Status)) {
-                ERR("write_data returned %08x\n", Status);
-                ExFreePool(wtc);
-                return Status;
+
+        TRACE("address: %llx, size: %x\n", tw->address, tw->length);
+
+        KeInitializeEvent(&wtc[bit_num].Event, NotificationEvent, FALSE);
+        InitializeListHead(&wtc[bit_num].stripes);
+        wtc[bit_num].need_wait = FALSE;
+        wtc[bit_num].stripes_left = 0;
+        wtc[bit_num].parity1 = wtc[bit_num].parity2 = wtc[bit_num].scratch = NULL;
+        wtc[bit_num].mdl = wtc[bit_num].parity1_mdl = wtc[bit_num].parity2_mdl = NULL;
+
+        Status = write_data(Vcb, tw->address, tw->data, tw->length, &wtc[bit_num], NULL, NULL, FALSE, 0, HighPagePriority);
+        if (!NT_SUCCESS(Status)) {
+            ERR("write_data returned %08x\n", Status);
+
+            for (i = 0; i < num_bits; i++) {
+                free_write_data_stripes(&wtc[i]);
             }
+            ExFreePool(wtc);
+
+            return Status;
         }
-        
+
+        bit_num++;
+
         le = le->Flink;
     }
-    
-    if (wtc->stripes.Flink != &wtc->stripes) {
-        // launch writes and wait
-        le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
-            write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-            
-            if (stripe->status != WriteDataStatus_Ignore)
-                IoCallDriver(stripe->device->devobj, stripe->Irp);
-            
-            le = le->Flink;
+
+    for (i = 0; i < num_bits; i++) {
+        if (wtc[i].stripes.Flink != &wtc[i].stripes) {
+            // launch writes and wait
+            le = wtc[i].stripes.Flink;
+            while (le != &wtc[i].stripes) {
+                write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
+
+                if (stripe->status != WriteDataStatus_Ignore) {
+                    wtc[i].need_wait = TRUE;
+                    IoCallDriver(stripe->device->devobj, stripe->Irp);
+                }
+
+                le = le->Flink;
+            }
         }
-        
-        KeWaitForSingleObject(&wtc->Event, Executive, KernelMode, FALSE, NULL);
-        
-        le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
+    }
+
+    for (i = 0; i < num_bits; i++) {
+        if (wtc[i].need_wait)
+            KeWaitForSingleObject(&wtc[i].Event, Executive, KernelMode, FALSE, NULL);
+    }
+
+    for (i = 0; i < num_bits; i++) {
+        le = wtc[i].stripes.Flink;
+        while (le != &wtc[i].stripes) {
             write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-            
+
             if (stripe->status != WriteDataStatus_Ignore && !NT_SUCCESS(stripe->iosb.Status)) {
                 Status = stripe->iosb.Status;
+                log_device_error(Vcb, stripe->device, BTRFS_DEV_STAT_WRITE_ERRORS);
                 break;
             }
-            
+
             le = le->Flink;
         }
-        
-        free_write_data_stripes(wtc);
+
+        free_write_data_stripes(&wtc[i]);
     }
-    
-    le = tree_writes->Flink;
-    while (le != tree_writes) {
-        tw = CONTAINING_RECORD(le, tree_write, list_entry);
-        
-        if (tw->overlap) {
-            TRACE("address: %llx, size: %x, overlap = %u\n", tw->address, tw->length, tw->overlap);
-            
-            Status = write_data_complete(Vcb, tw->address, tw->data, tw->length, Irp, NULL);
-            if (!NT_SUCCESS(Status)) {
-                ERR("write_data_complete returned %08x\n", Status);
-                ExFreePool(wtc);
-                return Status;
+
+    ExFreePool(wtc);
+
+    if (raid56) {
+        c = NULL;
+
+        le = tree_writes->Flink;
+        while (le != tree_writes) {
+            tw = CONTAINING_RECORD(le, tree_write, list_entry);
+
+            if (tw->c != c) {
+                c = tw->c;
+
+                ExAcquireResourceExclusiveLite(&c->partial_stripes_lock, TRUE);
+
+                while (!IsListEmpty(&c->partial_stripes)) {
+                    partial_stripe* ps = CONTAINING_RECORD(RemoveHeadList(&c->partial_stripes), partial_stripe, list_entry);
+
+                    Status = flush_partial_stripe(Vcb, c, ps);
+
+                    if (ps->bmparr)
+                        ExFreePool(ps->bmparr);
+
+                    ExFreePool(ps);
+
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("flush_partial_stripe returned %08x\n", Status);
+                        ExReleaseResourceLite(&c->partial_stripes_lock);
+                        return Status;
+                    }
+                }
+
+                ExReleaseResourceLite(&c->partial_stripes_lock);
             }
+
+            le = le->Flink;
         }
-        
-        le = le->Flink;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
 static NTSTATUS write_trees(device_extension* Vcb, PIRP Irp) {
-    UINT8 level;
+    ULONG level;
     UINT8 *data, *body;
     UINT32 crc32;
     NTSTATUS Status;
@@ -1354,31 +1679,30 @@
     LIST_ENTRY* le;
     LIST_ENTRY tree_writes;
     tree_write* tw;
-    
+
     TRACE("(%p)\n", Vcb);
-    
+
     InitializeListHead(&tree_writes);
 
     for (level = 0; level <= 255; level++) {
         BOOL nothing_found = TRUE;
-        
+
         TRACE("level = %u\n", level);
-        
+
         le = Vcb->trees.Flink;
         while (le != &Vcb->trees) {
             tree* t = CONTAINING_RECORD(le, tree, list_entry);
-            
+
             if (t->write && t->header.level == level) {
                 KEY firstitem, searchkey;
                 LIST_ENTRY* le2;
                 traverse_ptr tp;
-                EXTENT_ITEM_TREE* eit;
-                
+
                 if (!t->has_new_address) {
                     ERR("error - tried to write tree with no new address\n");
-                    int3;
+                    return STATUS_INTERNAL_ERROR;
                 }
-                
+
                 le2 = t->itemlist.Flink;
                 while (le2 != &t->itemlist) {
                     tree_data* td = CONTAINING_RECORD(le2, tree_data, list_entry);
@@ -1388,127 +1712,116 @@
                     }
                     le2 = le2->Flink;
                 }
-                
+
                 if (t->parent) {
                     t->paritem->key = firstitem;
                     t->paritem->treeholder.address = t->new_address;
                     t->paritem->treeholder.generation = Vcb->superblock.generation;
                 }
-                
+
                 if (!(Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA)) {
+                    EXTENT_ITEM_TREE* eit;
+
                     searchkey.obj_id = t->new_address;
                     searchkey.obj_type = TYPE_EXTENT_ITEM;
                     searchkey.offset = Vcb->superblock.node_size;
-                    
+
                     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
                     if (!NT_SUCCESS(Status)) {
                         ERR("error - find_item returned %08x\n", Status);
                         return Status;
                     }
-                    
+
                     if (keycmp(searchkey, tp.item->key)) {
-//                         traverse_ptr next_tp;
-//                         BOOL b;
-//                         tree_data* paritem;
-                        
                         ERR("could not find %llx,%x,%llx in extent_root (found %llx,%x,%llx instead)\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-                        
-//                         searchkey.obj_id = 0;
-//                         searchkey.obj_type = 0;
-//                         searchkey.offset = 0;
-//                         
-//                         find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE);
-//                         
-//                         paritem = NULL;
-//                         do {
-//                             if (tp.tree->paritem != paritem) {
-//                                 paritem = tp.tree->paritem;
-//                                 ERR("paritem: %llx,%x,%llx\n", paritem->key.obj_id, paritem->key.obj_type, paritem->key.offset);
-//                             }
-//                             
-//                             ERR("%llx,%x,%llx\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-//                             
-//                             b = find_next_item(Vcb, &tp, &next_tp, NULL, FALSE);
-//                             if (b) {
-//                                 free_traverse_ptr(&tp);
-//                                 tp = next_tp;
-//                             }
-//                         } while (b);
-//                         
-//                         free_traverse_ptr(&tp);
-                        
                         return STATUS_INTERNAL_ERROR;
                     }
-                    
+
                     if (tp.item->size < sizeof(EXTENT_ITEM_TREE)) {
                         ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM_TREE));
                         return STATUS_INTERNAL_ERROR;
                     }
-                    
+
                     eit = (EXTENT_ITEM_TREE*)tp.item->data;
                     eit->firstitem = firstitem;
                 }
-                
+
                 nothing_found = FALSE;
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (nothing_found)
             break;
     }
-    
+
     TRACE("allocated tree extents\n");
-    
+
     le = Vcb->trees.Flink;
     while (le != &Vcb->trees) {
         tree* t = CONTAINING_RECORD(le, tree, list_entry);
+        LIST_ENTRY* le2;
 #ifdef DEBUG_PARANOID
         UINT32 num_items = 0, size = 0;
-        LIST_ENTRY* le2;
         BOOL crash = FALSE;
 #endif
 
         if (t->write) {
 #ifdef DEBUG_PARANOID
+            BOOL first = TRUE;
+            KEY lastkey;
+
             le2 = t->itemlist.Flink;
             while (le2 != &t->itemlist) {
                 tree_data* td = CONTAINING_RECORD(le2, tree_data, list_entry);
                 if (!td->ignore) {
                     num_items++;
-                    
+
+                    if (!first) {
+                        if (keycmp(td->key, lastkey) == 0) {
+                            ERR("(%llx,%x,%llx): duplicate key\n", td->key.obj_id, td->key.obj_type, td->key.offset);
+                            crash = TRUE;
+                        } else if (keycmp(td->key, lastkey) == -1) {
+                            ERR("(%llx,%x,%llx): key out of order\n", td->key.obj_id, td->key.obj_type, td->key.offset);
+                            crash = TRUE;
+                        }
+                    } else
+                        first = FALSE;
+
+                    lastkey = td->key;
+
                     if (t->header.level == 0)
                         size += td->size;
                 }
                 le2 = le2->Flink;
             }
-            
+
             if (t->header.level == 0)
                 size += num_items * sizeof(leaf_node);
             else
                 size += num_items * sizeof(internal_node);
-            
+
             if (num_items != t->header.num_items) {
                 ERR("tree %llx, level %x: num_items was %x, expected %x\n", t->root->id, t->header.level, num_items, t->header.num_items);
                 crash = TRUE;
             }
-            
+
             if (size != t->size) {
                 ERR("tree %llx, level %x: size was %x, expected %x\n", t->root->id, t->header.level, size, t->size);
                 crash = TRUE;
             }
-            
+
             if (t->header.num_items == 0 && t->parent) {
                 ERR("tree %llx, level %x: tried to write empty tree with parent\n", t->root->id, t->header.level);
                 crash = TRUE;
             }
-            
+
             if (t->size > Vcb->superblock.node_size - sizeof(tree_header)) {
                 ERR("tree %llx, level %x: tried to write overlarge tree (%x > %x)\n", t->root->id, t->header.level, t->size, Vcb->superblock.node_size - sizeof(tree_header));
                 crash = TRUE;
             }
-            
+
             if (crash) {
                 ERR("tree %p\n", t);
                 le2 = t->itemlist.Flink;
@@ -1528,7 +1841,7 @@
             t->header.flags |= HEADER_FLAG_MIXED_BACKREF;
             t->header.fs_uuid = Vcb->superblock.uuid;
             t->has_address = TRUE;
-            
+
             data = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.node_size, ALLOC_TAG);
             if (!data) {
                 ERR("out of memory\n");
@@ -1535,40 +1848,38 @@
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end;
             }
-            
+
             body = data + sizeof(tree_header);
-            
+
             RtlCopyMemory(data, &t->header, sizeof(tree_header));
             RtlZeroMemory(body, Vcb->superblock.node_size - sizeof(tree_header));
-            
+
             if (t->header.level == 0) {
                 leaf_node* itemptr = (leaf_node*)body;
                 int i = 0;
-                LIST_ENTRY* le2;
                 UINT8* dataptr = data + Vcb->superblock.node_size;
-                
+
                 le2 = t->itemlist.Flink;
                 while (le2 != &t->itemlist) {
                     tree_data* td = CONTAINING_RECORD(le2, tree_data, list_entry);
                     if (!td->ignore) {
                         dataptr = dataptr - td->size;
-                        
+
                         itemptr[i].key = td->key;
-                        itemptr[i].offset = (UINT8*)dataptr - (UINT8*)body;
+                        itemptr[i].offset = (UINT32)((UINT8*)dataptr - (UINT8*)body);
                         itemptr[i].size = td->size;
                         i++;
-                        
+
                         if (td->size > 0)
                             RtlCopyMemory(dataptr, td->data, td->size);
                     }
-                    
+
                     le2 = le2->Flink;
                 }
             } else {
                 internal_node* itemptr = (internal_node*)body;
                 int i = 0;
-                LIST_ENTRY* le2;
-                
+
                 le2 = t->itemlist.Flink;
                 while (le2 != &t->itemlist) {
                     tree_data* td = CONTAINING_RECORD(le2, tree_data, list_entry);
@@ -1578,46 +1889,46 @@
                         itemptr[i].generation = td->treeholder.generation;
                         i++;
                     }
-                    
+
                     le2 = le2->Flink;
                 }
             }
-            
+
             crc32 = calc_crc32c(0xffffffff, (UINT8*)&((tree_header*)data)->fs_uuid, Vcb->superblock.node_size - sizeof(((tree_header*)data)->csum));
             crc32 = ~crc32;
             *((UINT32*)data) = crc32;
             TRACE("setting crc32 to %08x\n", crc32);
-            
+
             tw = ExAllocatePoolWithTag(PagedPool, sizeof(tree_write), ALLOC_TAG);
             if (!tw) {
                 ERR("out of memory\n");
-                return STATUS_INSUFFICIENT_RESOURCES;
+                ExFreePool(data);
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto end;
             }
-            
+
             tw->address = t->new_address;
             tw->length = Vcb->superblock.node_size;
             tw->data = data;
-            tw->overlap = FALSE;
-            
+
             if (IsListEmpty(&tree_writes))
                 InsertTailList(&tree_writes, &tw->list_entry);
             else {
-                LIST_ENTRY* le2;
                 BOOL inserted = FALSE;
-                
+
                 le2 = tree_writes.Flink;
                 while (le2 != &tree_writes) {
                     tree_write* tw2 = CONTAINING_RECORD(le2, tree_write, list_entry);
-                    
+
                     if (tw2->address > tw->address) {
                         InsertHeadList(le2->Blink, &tw->list_entry);
                         inserted = TRUE;
                         break;
                     }
-                    
+
                     le2 = le2->Flink;
                 }
-                
+
                 if (!inserted)
                     InsertTailList(&tree_writes, &tw->list_entry);
             }
@@ -1625,13 +1936,13 @@
 
         le = le->Flink;
     }
-    
-    Status = do_tree_writes(Vcb, &tree_writes, Irp);
+
+    Status = do_tree_writes(Vcb, &tree_writes, FALSE);
     if (!NT_SUCCESS(Status)) {
         ERR("do_tree_writes returned %08x\n", Status);
         goto end;
     }
-    
+
     Status = STATUS_SUCCESS;
 
 end:
@@ -1638,10 +1949,13 @@
     while (!IsListEmpty(&tree_writes)) {
         le = RemoveHeadList(&tree_writes);
         tw = CONTAINING_RECORD(le, tree_write, list_entry);
-        
+
+        if (tw->data)
+            ExFreePool(tw->data);
+
         ExFreePool(tw);
     }
-    
+
     return Status;
 }
 
@@ -1648,9 +1962,9 @@
 static void update_backup_superblock(device_extension* Vcb, superblock_backup* sb, PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp;
-    
+
     RtlZeroMemory(sb, sizeof(superblock_backup));
-    
+
     sb->root_tree_addr = Vcb->superblock.root_tree_addr;
     sb->root_tree_generation = Vcb->superblock.generation;
     sb->root_level = Vcb->superblock.root_level;
@@ -1662,11 +1976,11 @@
     searchkey.obj_id = BTRFS_ROOT_EXTENT;
     searchkey.obj_type = TYPE_ROOT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     if (NT_SUCCESS(find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp))) {
         if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type && tp.item->size >= sizeof(ROOT_ITEM)) {
             ROOT_ITEM* ri = (ROOT_ITEM*)tp.item->data;
-            
+
             sb->extent_tree_addr = ri->block_number;
             sb->extent_tree_generation = ri->generation;
             sb->extent_root_level = ri->root_level;
@@ -1674,23 +1988,23 @@
     }
 
     searchkey.obj_id = BTRFS_ROOT_FSTREE;
-    
+
     if (NT_SUCCESS(find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp))) {
         if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type && tp.item->size >= sizeof(ROOT_ITEM)) {
             ROOT_ITEM* ri = (ROOT_ITEM*)tp.item->data;
-            
+
             sb->fs_tree_addr = ri->block_number;
             sb->fs_tree_generation = ri->generation;
             sb->fs_root_level = ri->root_level;
         }
     }
-    
+
     searchkey.obj_id = BTRFS_ROOT_DEVTREE;
-    
+
     if (NT_SUCCESS(find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp))) {
         if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type && tp.item->size >= sizeof(ROOT_ITEM)) {
             ROOT_ITEM* ri = (ROOT_ITEM*)tp.item->data;
-            
+
             sb->dev_root_addr = ri->block_number;
             sb->dev_root_generation = ri->generation;
             sb->dev_root_level = ri->root_level;
@@ -1698,11 +2012,11 @@
     }
 
     searchkey.obj_id = BTRFS_ROOT_CHECKSUM;
-    
+
     if (NT_SUCCESS(find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp))) {
         if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type && tp.item->size >= sizeof(ROOT_ITEM)) {
             ROOT_ITEM* ri = (ROOT_ITEM*)tp.item->data;
-            
+
             sb->csum_root_addr = ri->block_number;
             sb->csum_root_generation = ri->generation;
             sb->csum_root_level = ri->root_level;
